package test.jikesrvm;

import java.net.URL;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.Reader;

import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

public class XMLUtilities
{

  public static void parseXML(InputStream in, DefaultHandler handler) throws SAXException, IOException {
    XMLReader parser = XMLReaderFactory.createXMLReader();
    Reader r = new BufferedReader(new InputStreamReader(in));
    InputSource isrc = new InputSource(r);
    isrc.setSystemId("xml-parse-test.jar");
    parser.setEntityResolver(handler);
    parser.parse(isrc);
  }

  /**
   * findEntity will locate a resource inside the jar file and return it.
   */
  public static InputSource findEntity(String systemId, String test, Class where) throws IOException {
    System.out.println("findEntity: systemId: " + systemId + " test: " + test + " where: " + where);
    if (systemId != null && systemId.endsWith(test)) {
        URL url = where.getResource(test);
        System.out.println("url: " + url);
        return new InputSource(new BufferedReader(
          new InputStreamReader(
            where.getResourceAsStream(test))));
    }
    return null;
  }
}

